**PRIVACY NOTICE (Created with termly.io)**

**Last updated April 21, 2023**

This privacy notice for XPipe, in which ("**we**," "**us**," or "**our**") refers to Christopher Schnick, describes how
and why we
might collect, store, use, and/or share ("**process**") your information when you use our services ("**Services**"),
such as when you:

* Download and use our application (XPipe), or any other application of ours that links to this privacy notice

**Questions or concerns?** Reading this privacy notice will help you understand your privacy rights and choices. If you
do not agree with our policies and practices, please do not use our Services. If you still have any questions or
concerns, please contact us at hello@xpipe.io.

<a name="toc"></a> **TABLE OF CONTENTS**

[1\. WHAT INFORMATION DO WE COLLECT?](#infocollect)

[2\. HOW DO WE PROCESS YOUR INFORMATION?](#infouse)

[3\. WHAT LEGAL BASES DO WE RELY ON TO PROCESS YOUR PERSONAL INFORMATION?](#legalbases)

[4\. WHEN AND WITH WHOM DO WE SHARE YOUR PERSONAL INFORMATION?](#whoshare)

[5\. IS YOUR INFORMATION TRANSFERRED INTERNATIONALLY?](#intltransfers)

[6\. HOW LONG DO WE KEEP YOUR INFORMATION?](#inforetain)

[7\. HOW DO WE KEEP YOUR INFORMATION SAFE?](#infosafe)

[8\. WHAT ARE YOUR PRIVACY RIGHTS?](#privacyrights)

[9\. DO CALIFORNIA RESIDENTS HAVE SPECIFIC PRIVACY RIGHTS?](#caresidents)

[10\. DO WE MAKE UPDATES TO THIS NOTICE?](#policyupdates)

[11\. HOW CAN YOU CONTACT US ABOUT THIS NOTICE?](#contact)

[12\. HOW CAN YOU REVIEW, UPDATE, OR DELETE THE DATA WE COLLECT FROM YOU?](#request)

<a name="infocollect"></a> **1\. WHAT INFORMATION DO WE COLLECT?**

**Personal information you disclose to us**

We collect personal information that you voluntarily provide to us when you express an interest in obtaining information
about us or our products and Services, or otherwise when you contact us, for example by emailing us.

**Sensitive Information.** We do not process sensitive information.

**Error reports.** If you encounter and report application errors using the issue reporter,
we also may collect the following information if you choose to
provide us with access or permission:

* _Device Data._ Device information (such as your device ID, model, and
  manufacturer), operating system, version information, and application identification numbers.

* _Log and Usage Data. (Optional choice)_ Log and usage data is service-related, diagnostic, usage, and performance information our
  servers automatically collect when you access or use our Services and which we record in log files. Depending on how
  you interact with us, this log data may include your IP address, device information, and settings and
  information about your activity in the Services (such as the date/time stamps associated with your usage, pages and
  files viewed, searches, and other actions you take such as which features you use), device event information (such as
  system activity, error reports (sometimes called "crash dumps"), and hardware settings).

* _Error Diagnostics Information. (Optional choice)_ Information relating to a specific error that occurred in the application. This may
  include application logs, event data, and any other kind of data that is used to diagnose the error.

This information is primarily needed to maintain the security and operation of our application(s), for troubleshooting,
and for our internal analytics and reporting purposes.

<a name="infouse"></a> **2\. HOW DO WE PROCESS YOUR INFORMATION?**

**We process your personal information for a variety of reasons, depending on how you interact with our Services,
including:**

* **To protect our Services.** We may process your information as part of our efforts to keep our Services safe and
  secure, including error and exploit monitoring and prevention.

* **To save or protect an individual's vital interest.** We may process your information when necessary to save or
  protect an individual’s vital interest, such as to prevent harm.

<a name="legalbases"></a> **3\. WHAT LEGAL BASES DO WE RELY ON TO PROCESS YOUR INFORMATION?**

_**In Short:** We only process your personal information when we believe it is necessary and we have a valid legal
reason (i.e., legal basis) to do so under applicable law, like with your consent, to comply with laws, to provide you
with services to enter into or fulfill our contractual obligations, to protect your rights, or to fulfill our legitimate
business interests._

_**If you are located in the EU or UK, this section applies to you.**_

The General Data Protection Regulation (GDPR) and UK GDPR require us to explain the valid legal bases we rely on in
order to process your personal information. As such, we may rely on the following legal bases to process your personal
information:

* **Consent.** We may process your information if you have given us permission (i.e., consent) to use your personal
  information for a specific purpose. You can withdraw your consent at any time. Click [here](#request) to learn
  more.

* **Legitimate Interests.** We may process your information when we believe it is reasonably necessary to achieve our
  legitimate business interests and those interests do not outweigh your interests and fundamental rights and freedoms.
  For example, we may process your personal information for some of the purposes described in order to:

* Diagnose problems and/or prevent errors and exploits

* Understand how our users use our products and services so we can improve user experience

* **Legal Obligations.** We may process your information where we believe it is necessary for compliance with our legal
  obligations, such as to cooperate with a law enforcement body or regulatory agency, exercise or defend our legal
  rights, or disclose your information as evidence in litigation in which we are involved.


* **Vital Interests.** We may process your information where we believe it is necessary to protect your vital interests
  or the vital interests of a third party, such as situations involving potential threats to the safety of any person.

In legal terms, we are generally the "data controller" under European data protection laws of the personal information
described in this privacy notice, since we determine the means and/or purposes of the data processing we perform. This
privacy notice does not apply to the personal information we process as a "data processor" on behalf of our customers.
In those situations, the customer that we provide services to and with whom we have entered into a data processing
agreement is the "data controller" responsible for your personal information, and we merely process your information on
their behalf in accordance with your instructions. If you want to know more about our customers' privacy practices, you
should read their privacy policies and direct any questions you have to them.

**_If you are located in Canada, this section applies to you._**

We may process your information if you have given us specific permission (i.e., express consent) to use your personal
information for a specific purpose, or in situations where your permission can be inferred (i.e., implied consent). You
can withdraw your consent at any time. Click [here](#request) to learn more.

In some exceptional cases, we may be legally permitted under applicable law to process your information without your
consent, including, for example:

* If collection is clearly in the interests of an individual and consent cannot be obtained in a timely way

* For investigations and fraud detection and prevention

* For business transactions provided certain conditions are met

* If it is contained in a witness statement and the collection is necessary to assess, process, or settle an insurance
  claim

* For identifying injured, ill, or deceased persons and communicating with next of kin

* If we have reasonable grounds to believe an individual has been, is, or may be victim of financial abuse

* If it is reasonable to expect collection and use with consent would compromise the availability or the accuracy of the
  information and the collection is reasonable for purposes related to investigating a breach of an agreement or a
  contravention of the laws of Canada or a province

* If disclosure is required to comply with a subpoena, warrant, court order, or rules of the court relating to the
  production of records

* If it was produced by an individual in the course of their employment, business, or profession and the collection is
  consistent with the purposes for which the information was produced

* If the collection is solely for journalistic, artistic, or literary purposes

* If the information is publicly available and is specified by the regulations

<a name="whoshare"></a> **4\. WHEN AND WITH WHOM DO WE SHARE YOUR PERSONAL INFORMATION?**

**_In Short:_** _We may share information in specific situations described in this section and/or with the following
third parties._

* **Error reporting and usage tracking**

**_Sentry_**:
Functional Software, Inc. dba Sentry, 45 Fremont Street, 8th Floor, San Francisco, CA 94105.
You can find their privacy policy here: [https://sentry.io/privacy/](https://sentry.io/privacy/)

<a name="intltransfers"></a> **5\. IS YOUR INFORMATION TRANSFERRED INTERNATIONALLY?**

**_In Short:_** _We may transfer, store, and process your information in countries other than your own._

Please be aware that your information may be transferred to, stored, and processed by us in our
facilities and by those third parties with whom we may share your personal information (
see "[WHEN AND WITH WHOM DO WE SHARE YOUR PERSONAL INFORMATION?](#whoshare)" above), in the United States, and other
countries.

If you are a resident in the European Economic Area (EEA) or United Kingdom (UK), then these countries may not
necessarily have data protection laws or other similar laws as comprehensive as those in your country. However, we will
take all necessary measures to protect your personal information in accordance with this privacy notice and applicable
law.

European Commission's Standard Contractual Clauses:

We have implemented measures to protect your personal information, including by using the European Commission's Standard
Contractual Clauses for transfers of personal information between our group companies and between us and our third-party
providers. These clauses require all recipients to protect all personal information that they process originating from
the EEA or UK in accordance with European data protection laws and regulations. Our Data Processing Agreements that
include Standard Contractual Clauses are available here: [https://sentry.io/legal/dpa/](https://sentry.io/legal/dpa/).
We have implemented similar appropriate safeguards with our third-party service providers and partners and further
details can be provided upon request.

<a name="inforetain"></a> **6\. HOW LONG DO WE KEEP YOUR INFORMATION?**

**_In Short:_** _We keep your information for as long as necessary to fulfill the purposes outlined in this privacy
notice unless otherwise required by law._

We will only keep your personal information for as long as it is necessary for the purposes set out in this privacy
notice, unless a longer retention period is required or permitted by law (such as tax, accounting, or other legal
requirements).

When we have no ongoing legitimate business need to process your personal information, we will either delete or
anonymize such information, or, if this is not possible (for example, because your personal information has been stored
in backup archives), then we will securely store your personal information and isolate it from any further processing
until deletion is possible.

<a name="infosafe"></a> **7\. HOW DO WE KEEP YOUR INFORMATION SAFE?**

**_In Short:_** _We aim to protect your personal information through a system of organizational and technical security
measures._

We have implemented appropriate and reasonable technical and organizational security measures designed to protect the
security of any personal information we process. However, despite our safeguards and efforts to secure your information,
no electronic transmission over the Internet or information storage technology can be guaranteed to be 100% secure, so
we cannot promise or guarantee that hackers, cybercriminals, or other unauthorized third parties will not be able to
defeat our security and improperly collect, access, steal, or modify your information. Although we will do our best to
protect your personal information, transmission of personal information to and from our Services is at your own risk.
You should only access the Services within a secure environment.

<a name="privacyrights"></a> **8\. WHAT ARE YOUR PRIVACY RIGHTS?**

**_In Short:_** _In some regions, such as the European Economic Area (EEA), United Kingdom (UK), and Canada, you have
rights that allow you greater access to and control over your personal information. You may review, change, or terminate
your account at any time._

In some regions (like the EEA, UK, and Canada), you have certain rights under applicable data protection laws. These may
include the right (i) to request access and obtain a copy of your personal information, (ii) to request rectification or
erasure; (iii) to restrict the processing of your personal information; and (iv) if applicable, to data portability. In
certain circumstances, you may also have the right to object to the processing of your personal information. You can
make such a request by contacting us by using the contact details provided in the
section "[HOW CAN YOU CONTACT US ABOUT THIS NOTICE?](#contact)" below.

We will consider and act upon any request in accordance with applicable data protection laws.

If you are located in the EEA or UK and you believe we are unlawfully processing your personal information, you also
have the right to complain to your local data protection supervisory authority. You can find their contact details
here: [https://ec.europa.eu/justice/data-protection/bodies/authorities/index\_en.htm](https://ec.europa.eu/justice/data-protection/bodies/authorities/index_en.htm)
.

If you are located in Switzerland, the contact details for the data protection authorities are available
here: [https://www.edoeb.admin.ch/edoeb/en/home.html](https://www.edoeb.admin.ch/edoeb/en/home.html).

**Withdrawing your consent:** If we are relying on your consent to process your personal information, which may be
express and/or implied consent depending on the applicable law, you have the right to withdraw your consent at any time.
You can withdraw your consent at any time by contacting us by using the contact details provided in the
section "[HOW CAN YOU CONTACT US ABOUT THIS NOTICE?](#contact)" below.

However, please note that this will not affect the lawfulness of the processing before its withdrawal nor, when
applicable law allows, will it affect the processing of your personal information conducted in reliance on lawful
processing grounds other than consent.

If you have questions or comments about your privacy rights, you may email us at hello@xpipe.io.

<a name="caresidents"></a> **9\. DO CALIFORNIA RESIDENTS HAVE SPECIFIC PRIVACY RIGHTS?**

**_In Short:_** _Yes, if you are a resident of California, you are granted specific rights regarding access to your
personal information._

California Civil Code Section 1798.83, also known as the "Shine The Light" law, permits our users who are California
residents to request and obtain from us, once a year and free of charge, information about categories of personal
information (if any) we disclosed to third parties for direct marketing purposes and the names and addresses of all
third parties with which we shared personal information in the immediately preceding calendar year. If you are a
California resident and would like to make such a request, please submit your request in writing to us using the contact
information provided below.

If you are under 18 years of age, reside in California, and have a registered account with Services, you have the right
to request removal of unwanted data that you publicly post on the Services. To request removal of such data, please
contact us using the contact information provided below and include the email address associated with your account and a
statement that you reside in California. We will make sure the data is not publicly displayed on the Services, but
please be aware that the data may not be completely or comprehensively removed from all our systems (e.g., backups,
etc.).

<a name="policyupdates"></a> **10\. DO WE MAKE UPDATES TO THIS NOTICE?**

_**In Short:** Yes, we will update this notice as necessary to stay compliant with relevant laws._

We may update this privacy notice from time to time. The updated version will be indicated by an updated "Revised" date
and the updated version will be effective as soon as it is accessible. If we make material changes to this privacy
notice, we may notify you either by prominently posting a notice of such changes or by directly sending you a
notification. We encourage you to review this privacy notice frequently to be informed of how we are protecting your
information.

<a name="contact"></a> **11\. HOW CAN YOU CONTACT US ABOUT THIS NOTICE?**

If you have questions or comments about this notice, you may contact Christopher
Schnick by email at crschnick@xpipe.io.

<a name="request"></a> **12\. HOW CAN YOU REVIEW, UPDATE, OR DELETE THE DATA WE COLLECT FROM YOU?**

Based on the applicable laws of your country, you may have the right to request access to the personal information we
collect from you, change that information, or delete it. To request to review, update, or delete your personal
information, please submit a request form by writing to hello@xpipe.io.
